<?php

/*

Plugin Name:Advance wooCommerce Search (P30vel.ir)

Plugin URI: http://www.p30vel.ir/tag/Advance-wooCommerce-Search

Description: Search wooCommerce products by name, category, tags in a super fast way.

Author: P30vel.ir

Version: 1.4.2

*/



/**************************************************************************************************/

/**********************************Plugin Constants***********************************************/

/**************************************************************************************************/

define('AWS_PLUGIN_BASE',plugin_dir_url(__FILE__));

define('AWS_PLUGIN_BASE_PATH',plugin_dir_path(__FILE__));

define('AWS_PLUGIN_CSS',AWS_PLUGIN_BASE.'css');

define('AWS_PLUGIN_JS',AWS_PLUGIN_BASE.'js');

define('AWS_PLUGIN_IMAGES',AWS_PLUGIN_BASE.'images');

define('AWS_PLUGIN_DATA',AWS_PLUGIN_BASE.'data');





/*************************************************************************************************/

/**********************************register hook***************************************************/

/**************************************************************************************************/

register_activation_hook(__FILE__,'aws_register_init');

function aws_register_init(){

	

	if ( !class_exists( 'WooCommerce' ) ) {

		

		 deactivate_plugins( plugin_basename( __FILE__ ) );

		 add_action( 'admin_notices', 'plugin_deactivation_case_admin_message' );

		 return;

	}

	

 $aws_admin_settings=array(	 

			

	 'aws_product_category_lbl'=> __('Categories','aws'),

	 'aws_product_tags_lbl'=> __('Tags','aws'),

	 'aws_no_of_search_results'=> 10,

    'aws_replace_product_search'=>'no',	 

	 'aws_order_by_search'=>'price',	

	 'aws_order_search'=>'DESC',

	 'aws_appearance_background_color'=>'',

     'aws_appearance_header_color'=> '',

	 'aws_appearance_header_text_color'=> '',

	 'aws_appearance_product_title_color'=> '',

	 'aws_appearance_text_color'=>'',
	 
	 'aws_exclude_categories'=>array(),
	 
	 'aws_exclude_tags'=>array(),

 );	 

 

 add_option('aws_admin_settings',$aws_admin_settings);

 add_option('aws_fisrt_update','no');

 add_option('aws_data_source','');

 



}



function aws_product_source_init(){

	$aws_fisrt_update=get_option('aws_fisrt_update');

	 $allowed_population=(isset($aws_fisrt_update) && $aws_fisrt_update=='no');

	 if(FALSE==$allowed_population) return;

	 

	 aws_product_results_souce(); //update data source

}

add_action('wp','aws_product_source_init');



/*************************************************************************************************/

/**********************************front plugin functions*****************************************/

/**************************************************************************************************/

require_once('inc/front/aws-front.php');



/*************************************************************************************************/

/**********************************admin functions*************************************************/

/**************************************************************************************************/

require_once('inc/admin/aws-admin.php');



/************************************************************************************************/

/*************************************required scripts and styles*******************************/

/**************************************************************************************************/

//front scripts

function aws_front_scripts(){      if(is_admin()) return;    

    wp_enqueue_script( 'jquery');

    wp_enqueue_script('aws_plugin_script', AWS_PLUGIN_JS.'/front/aws_plugin_script.js',array('jquery'),null, false);

    wp_localize_script( 'aws_plugin_script', 'aws_plugin_vars', aws_localize_js_plugin_vars());

    wp_enqueue_script('mCustomScrollbar_script', AWS_PLUGIN_JS.'/front/jquery.mCustomScrollbar.concat.min.js',array('jquery'),null, false);

	

}

add_action('wp_print_scripts', 'aws_front_scripts');



function aws_localize_js_plugin_vars(){  

     $aws_settings=get_option('aws_admin_settings');

	 

	  $count_posts = wp_count_posts('product');

     $published_posts = $count_posts->publish;

	 

	return array(

	     'ajaxurl'=>admin_url( 'admin-ajax.php' ),

		 'home_url'=>home_url(),

		'woocommerce_enabled'=>(class_exists( 'WooCommerce' )) ? 'yes' :'no',	

         'sort_field'=>$aws_settings['aws_order_by_search'],	

		 'order'=>$aws_settings['aws_order_search'],		 

		'search_results_count'=>(isset($aws_settings['aws_no_of_search_results']) && $aws_settings['aws_no_of_search_results'] ) ? $aws_settings['aws_no_of_search_results'] : 10,

		

		'hide_thumb'=>(isset($aws_settings['aws_hide_thumb']) && $aws_settings['aws_hide_thumb']=='yes' ) ? true : false,

		'hide_description'=>(isset($aws_settings['aws_hide_description']) && $aws_settings['aws_hide_description']=='yes' ) ? true : false,

		'hide_price'=>(isset($aws_settings['aws_hide_price']) && $aws_settings['aws_hide_price']=='yes' ) ? true : false,

		

		

		'all_result_count'=>(int)$published_posts,

		'tr_txt_view_all'=>__('View all','aws'),

		'tr_txt_products'=>__('Products','aws'),

		'tr_txt_result_not_found'=>__('Results not found','aws'),

		'tr_txt_view_all_products'=>__('View all Products','aws'),

	);

}

/**********multilinugal language support**********/

add_action('plugins_loaded', 'aws_plugin_init'); 

function aws_plugin_init() {

		load_plugin_textdomain( 'aws', false, dirname(plugin_basename(__FILE__)).'/languages/' );

}




//admin scripts

function aws_admin_scripts(){

	if(!(isset($_GET['page']) && $_GET['page']=='aws_plugin_settings_menu')) return;

    wp_enqueue_script('aws_plugin_color_picker_admin_script', AWS_PLUGIN_JS.'/admin/jscolor.js',array('jquery'),null, true);

}

add_action('admin_print_scripts', 'aws_admin_scripts');







//front styles

function aws_front_styles(){

	wp_enqueue_style('aws_plugin_front_style', AWS_PLUGIN_CSS.'/front/aws-plugin-style.css',array(),null, 'screen');

	wp_enqueue_style('mCustomScrollbar_style', AWS_PLUGIN_CSS.'/front/jquery.mCustomScrollbar.min.css',array(),null, 'screen');

}

add_action('wp_print_styles', 'aws_front_styles');



//admin styles

function aws_admin_styles(){

	wp_enqueue_style('aws_plugin_admin_style', AWS_PLUGIN_CSS.'/admin/aws-admin-style.css',array(),null, 'screen');

}

add_action('admin_print_styles', 'aws_admin_styles');