<?php 



add_action( 'transition_post_status', 'aws_product_results_on_post_status', 10, 3 );

function aws_product_results_on_post_status( $new_status, $old_status, $post )

{

	

	   if(get_post_type($post->ID) !=='product') return;

	   

	    $reg_price=isset($_POST['_regular_price']) ? floatval(trim($_POST['_regular_price'])) : 0;

		$sel_price=isset($_POST['_sale_price']) ? floatval(trim($_POST['_sale_price'])) : 0;
		
		$sku=isset($_POST['_sku']) ? trim($_POST['_sku']) : '';
			
		
		



		if('publish' === $old_status && 'publish' === $new_status){
			

			 update_post_meta($post->ID,'_regular_price',$reg_price);

			 update_post_meta($post->ID,'_sale_price',$sel_price);
			 
			 update_post_meta($post->ID,'_sku',$sku);

			 
			 update_single_post($post->ID);

			 
		}else if('draft'===$old_status && 'publish'===$new_status){

			  update_post_meta($post->ID,'_regular_price',$reg_price);

			 update_post_meta($post->ID,'_sale_price',$sel_price);
			 
			 update_post_meta($post->ID,'_sku',$sku);

			 
			  update_post_on_insert($post->ID);

			  

      }else if(('publish' === $old_status && 'trash' === $new_status) || ('publish' === $old_status && 'draft' === $new_status) || ('publish' === $old_status && 'pending' === $new_status) || ('publish' === $old_status && 'private' === $new_status)){

			update_posts_on_delete($post->ID);

		
		}else if(('trash' === $old_status && 'publish' === $new_status) || ('pending'===$old_status && 'publish'===$new_status) || ('private'===$old_status && 'publish'===$new_status)){

			
			update_post_on_insert($post->ID);

		
		}else{

			return;

		}

}

add_action( 'deleted_post', 'aws_product_results_on_delete',10,1);

function aws_product_results_on_delete($post_id){

       update_posts_on_delete($post_id);
}



function aws_populate_data(){

  	$json=json_encode(unserialize(get_option('aws_data_source')));
	echo $json;

    die();


}
add_action("wp_ajax_aws_populate_data", "aws_populate_data");

add_action("wp_ajax_nopriv_aws_populate_data", "aws_populate_data");



/************************* delete product from product results**************/ 
  function update_posts_on_delete($post_id){	

	if(get_post_type( $post_id) !=='product') return;

	

      $get_saved=unserialize(get_option('aws_data_source'));

	    

	if(!(isset($get_saved) && is_array($get_saved))) return;	

	

	    $new_saved=array();

		

		 foreach($get_saved as $saved){

 	

			if($saved['ID'] != $post_id){  /*** if not modified post simply append to the new saved array**/



			   array_push($new_saved,$saved);	

			}

	 }	
	 
	    $json_arr=serialize($new_saved);	

	   update_option('aws_data_source',$json_arr);

	}

	

	/************************* insert product from product results**************/

	function update_post_on_insert($post_id){

			if(get_post_type( $post_id) !=='product') return;


      $get_saved=unserialize(get_option('aws_data_source'));


	if(!(isset($get_saved) && is_array($get_saved))) return;	


	$price=(float)trim(get_post_meta( $post_id, '_sale_price', true));		


	$reg_price=(float)trim(get_post_meta( $post_id, '_regular_price', true));	
	
	 $sku=trim(get_post_meta($post_id,'_sku',true));	


	$updated_product_arr=array(	

	'ID'=>$post_id,		

	'title'=>get_the_title($post_id),	

	'description'=>wp_trim_words( get_content_by_id($post_id), 20, '...' ),	

	'url'=>get_permalink($post_id),		

	'price_html'=> ($price) ? woocommerce_price($price) : '',	

	'reg_price_html'=> ($reg_price) ? woocommerce_price($reg_price) : '',						 						 'reg_price'=> ($price) ? $price : $reg_price,
	'sku'=>$sku,

	'added_date'=>get_post_time('U',true,$post_id),	

	'last_modified_date'=>get_post_modified_time('U',true,$post_id)		


	);	


	$thumb_id = get_post_thumbnail_id($post_id);   

	$thumb_url_array = wp_get_attachment_image_src($thumb_id, 'thumbnail', true);  

	$thumb_url = $thumb_url_array[0];	

	$updated_product_arr['featurd_image']=$thumb_url;	

	$product_cat_array=array();	

	$product_category=get_the_terms( $post_id, 'product_cat' );	


	if ( $product_category && count($product_category) && ! is_wp_error( $product_category ) ) {	


		foreach($product_category as $cat){	

		array_push($product_cat_array,$cat->slug);	

		}											

	}	

	$updated_product_arr['categories']=$product_cat_array;

	$product_tag_array=array();	

	$product_tags=get_the_terms( $post_id, 'product_tag' );		

	if ( $product_tags && count($product_tags) && ! is_wp_error( $product_tags ) ) {	

		foreach($product_tags as $tag){	

		  array_push($product_tag_array,$tag->slug);	

		}	

	}	

	    $updated_product_arr['tags']=$product_tag_array;	

	   array_push($get_saved,$updated_product_arr);	  

	 $json_arr=serialize($get_saved);

	 update_option('aws_data_source',$json_arr);

	}

	
	/*******************************************************************/

	

	

	

	

	function update_single_post($post_id){	


	if(get_post_type( $post_id) !=='product') return;

     $get_saved=unserialize(get_option('aws_data_source'));

	   

	if(!(isset($get_saved) && is_array($get_saved))) return;	


	   $new_saved=array();	

	
	  foreach($get_saved as $saved){

 
	    if($saved['ID'] != $post_id){  /*** if not modified post simply append to the new saved array**/

	    array_push($new_saved,$saved);	

	   }else{ /**if modified post **/	

	   $price=(float)trim(get_post_meta( $post_id, '_sale_price', true));		



	   $reg_price=(float)trim(get_post_meta( $post_id, '_regular_price', true));	
	    $sku=trim(get_post_meta($post_id,'_sku',true));	



			$updated_product_arr=array(	

			'ID'=>$post_id,		

			'title'=>get_the_title($post_id),	

			'description'=>wp_trim_words( get_content_by_id($post_id), 20, '...' ),	

			'url'=>get_permalink($post_id),		

			'price_html'=> ($price) ? woocommerce_price($price) : '',	

			'reg_price_html'=> ($reg_price) ? woocommerce_price($reg_price) : '',						 				'reg_price'=> ($price) ? $price : $reg_price,
			'sku'=>$sku,

			'added_date'=>get_post_time('U',true,$post_id),	

			

			'last_modified_date'=>get_post_modified_time('U',true,$post_id)		



			);	



	     $thumb_id = get_post_thumbnail_id($post_id);   



	    $thumb_url_array = wp_get_attachment_image_src($thumb_id, 'thumbnail', true);  



	     $thumb_url = $thumb_url_array[0];	



	    $updated_product_arr['featurd_image']=$thumb_url;	



	   $product_cat_array=array();	



	    $product_category=get_the_terms( $post_id, 'product_cat' );	



		if ( $product_category && count($product_category) && ! is_wp_error( $product_category ) ) {	



			foreach($product_category as $cat){	



			array_push($product_cat_array,$cat->slug);	



			}											

		

		}	



	   $updated_product_arr['categories']=$product_cat_array;





	   $product_tag_array=array();	



	   $product_tags=get_the_terms( $post_id, 'product_tag' );		





		if ( $product_tags && count($product_tags) && ! is_wp_error( $product_tags ) ) {	





			foreach($product_tags as $tag){	





			array_push($product_tag_array,$tag->slug);	





			}	



		}	





	 $updated_product_arr['tags']=$product_tag_array;	



	  array_push($new_saved,$updated_product_arr);	

	





	  }



	 }/**end foreach**/

    

	 $json_arr=serialize($new_saved);



	 update_option('aws_data_source',$json_arr);

	 

	}
	
	
	
	function update_data_source_on_admin_settings_changed(){
		$new_source=array();
		$source=get_option('aws_data_source');
		if(!isset($source)) return;
		@$get_saved=unserialize($source);
		
		if(!(is_array($get_saved) && count($get_saved))) return;
		
		foreach($get_saved as $item){
			 $post_id=$item['ID'];
			 
					$price=(float)trim(get_post_meta( $post_id, '_sale_price', true));		
					$reg_price=(float)trim(get_post_meta( $post_id, '_regular_price', true));
                    $sku=trim(get_post_meta($post_id,'_sku',true));					

					$updated_product_arr=array(	
					'ID'=>$post_id,		
					'title'=>get_the_title($post_id),	
					'description'=>wp_trim_words( get_content_by_id($post_id), 20, '...' ),	
					'url'=>get_permalink($post_id),		
					'price_html'=> ($price) ? woocommerce_price($price) : '',	
					'reg_price_html'=> ($reg_price) ? woocommerce_price($reg_price) : '',						 			'reg_price'=> ($price) ? $price : $reg_price,
					'sku'=>$sku,
					'added_date'=>get_post_time('U',true,$post_id),	
					'last_modified_date'=>get_post_modified_time('U',true,$post_id)		
					);	
					
				 $thumb_id = get_post_thumbnail_id($post_id);   
				$thumb_url_array = wp_get_attachment_image_src($thumb_id, 'thumbnail', true);  
				 $thumb_url = $thumb_url_array[0];	
				$updated_product_arr['featurd_image']=$thumb_url;	


			   $product_cat_array=array();	
				$product_category=get_the_terms( $post_id, 'product_cat' );	
				if ( $product_category && count($product_category) && ! is_wp_error( $product_category ) ) {	
					foreach($product_category as $cat){	
					array_push($product_cat_array,$cat->slug);	
					}											
				}	
			   $updated_product_arr['categories']=$product_cat_array;

			   $product_tag_array=array();	
			   $product_tags=get_the_terms( $post_id, 'product_tag' );		

				if ( $product_tags && count($product_tags) && ! is_wp_error( $product_tags ) ) {	
					foreach($product_tags as $tag){	
					  array_push($product_tag_array,$tag->slug);	
					}	
				}	
			 $updated_product_arr['tags']=$product_tag_array;	
			 
	
			  if(is_product_category_in_exclude_list($post_id)){
				  $updated_product_arr['exclude_category_flag']='hide';	
			  }
			  else{
				   $updated_product_arr['exclude_category_flag']='show';	
			  }
			  
			   if(is_product_tag_in_exclude_list($post_id)){
				  $updated_product_arr['exclude_tag_flag']='hide';	
			  }
			  else{
				   $updated_product_arr['exclude_tag_flag']='show';	
			  }
			  
			  array_push($new_source,$updated_product_arr); 
		}
		
		 $json_arr=serialize($new_source);
		 
		 
	     update_option('aws_data_source',$json_arr);
	}
	
	
	function is_product_category_in_exclude_list($post_id){
		
		$term_list = wp_get_post_terms($post_id, 'product_cat', array("fields" => "ids"));
        
		if(!(is_array($term_list) && count($term_list))) return false;
		
		
		$aws_settings=get_option('aws_admin_settings');
		$exclude_list=$aws_settings['aws_exclude_categories'];
		$exclude_list=(isset($exclude_list) && is_array($exclude_list)) ? $exclude_list :array();
		
		foreach($term_list as $term){
			 if(in_array($term,$exclude_list)) return true;
			 continue;
		}
		return false;
		
	}
	function is_product_tag_in_exclude_list($post_id){
		
		$term_list = wp_get_post_terms($post_id, 'product_tag', array("fields" => "ids"));
        
		if(!(is_array($term_list) && count($term_list))) return false;
		
		$aws_settings=get_option('aws_admin_settings');
		$exclude_list=$aws_settings['aws_exclude_tags'];
		$exclude_list=(isset($exclude_list) && is_array($exclude_list)) ? $exclude_list :array();
		
		
		foreach($term_list as $term){
			 if(in_array($term,$exclude_list)) return true;
			 continue;
		}
		return false;
		
	}

	
	

	function is_product_exisit_in_saved($post_id,$arr){

		  if(count($arr)==0) return false;

		  

		  foreach($arr as $saved){

			  if($saved['ID'] == $post_id) return true;

		  }

		  return false;

		  

		  

	}

	function get_content_by_id($post_id){
		if(!$post_id) return;
		$content_post = get_post($post_id);	
		$content = $content_post->post_content;	
		$content = apply_filters('the_content', $content);	
		$content = str_replace(']]>', ']]&gt;', $content);	
		return $content;		

		}

